% Figure3_3.m
% It requires the following functions:
% spTVT2.m
% spTVT2m.m
% fKepler.m
% fKeplerT.m
% fKeplerV.m
% fKeplerVm.m
% phiKepler
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial and final time, and  Time step
global h
t0=0;  tf=200; 
for k=1:1
    for imet=1:4
t=[];
erEnE1=[]; erPosE1=[]; costE1=[];
erEnH2=[]; erPosH2=[]; costH2=[];
erEnSVT=[]; erPosSVT=[]; costSVT=[];
erEnSVTm=[]; erPosSVTm=[]; costSVTm=[];
% Initial Conditions 
e=0.2*(2-k);   
x0 = [1-e ; 0; 0; sqrt((1+e)/(1-e))];
q0=[x0(1); x0(2)];  p0=[x0(3); x0(4)]; 
% Energy at initial conditions
H0=((x0(3))^2+(x0(4))^2)/2-1/(sqrt((x0(1))^2+(x0(2))^2));

for i=1:9
   t=[];   x=[];  x1=[];   x2=[];  q2=[];  p2=[];  q2m=[];  p2m=[];
   N=20*2^i;  h = (tf-t0)/N;
   if imet==1
       nstages=6;
     [t q2 p2]=spVTVn(@fKeplerT,@fKeplerV,t0,tf,q0,p0,N);
   elseif imet==2
       nstages=2;
     [t q2 p2]=spVTVnProc(@fKeplerT,@fKeplerV,t0,tf,q0,p0,N);
   elseif imet==3
       nstages=1;
     [t q2 p2]=spVTVmProc(@fKeplerT,@fKeplerVm,t0,tf,q0,p0,N);
   else
       nstages=2;
     [t q2 p2]=spVTVm(@fKeplerT,@fKeplerVm,t0,tf,q0,p0,N);
   end

   x = x0'; th=t0; qin=q0; pin=p0;
   for i=1:N;
      th=th+h;
      [q p]=phiKepler(qin,pin,h);
      x=[x; q p];
      qin=q; pin=p;
   end

 eSVT=max(max(abs(x(:,1:2)-q2),abs(x(:,3:4)-p2)));
 errorSVT=((p2(:,1)).^2+(p2(:,2)).^2)./2-1./(sqrt((q2(:,1)).^2+(q2(:,2)).^2)) - H0;

    erPosSVT=[erPosSVT; max(eSVT)]; erEnSVT=[erEnSVT; max(abs(errorSVT))]; 
    costSVT=[costSVT; nstages*N];
end

  figure(2)
  subplot(1,2,2*k-1)
  hold on
  if imet==1
    plot(log10(costSVT),log10(erEnSVT(:)),'-ok','LineWidth',1.5)
%       text(2.9,-5.5,'N_{6}^{[4]}','FontSize',14)
  elseif imet==2
    plot(log10(costSVT),log10(erEnSVT(:)),'-sk','LineWidth',1.5)
  elseif imet==3
    plot(log10(costSVT),log10(erEnSVT(:)),'-dk','LineWidth',1.5)
  elseif imet==4
    plot(log10(costSVT),log10(erEnSVT(:)),'-pk','LineWidth',1.5)
  box
  end
%  axis([1.5 4.5 -4.5*k 1]) 
  axis([2.5 4 -7.5*k -1]) 
  xlabel('{\fontsize{14} log_{10}(N. eval.) }')   
  ylabel('{\fontsize{14} log_{10}(Err. En.)}')   

  subplot(1,2,2*k)
  hold on
  if imet==1
    plot(log10(costSVT),log10(erPosSVT(:)),'-ok','LineWidth',1.5)
  elseif imet==2
    plot(log10(costSVT),log10(erPosSVT(:)),'-sk','LineWidth',1.5)
  elseif imet==3
    plot(log10(costSVT),log10(erPosSVT(:)),'-dk','LineWidth',1.5)
  elseif imet==4
    plot(log10(costSVT),log10(erPosSVT(:)),'-pk','LineWidth',1.5)
  box
  end
%  axis([1.5 4.5 -2.5*k 1.5]) 
  axis([2.8 4.3 -6*k 0]) 
  xlabel('{\fontsize{14} log_{10}(N. eval.) }')   
  ylabel('{\fontsize{14} log_{10}(Err. Pos.)}')   
    end
end

