%             spVTVm.m
% Second order TVT-Splitting method
% fT, fV: the vectorfields
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t q p] = spVTVm(fT,fVm,t0,tf,q0,p0,N)
 h = (tf-t0)/N;

ns=2;
a=[1/2,1/2];
b=[1/6,2/3,1/6];
c=[0,1/72,0];

 
 ah=h*a; bh=h*b; ch3=h^3*c;
 t=t0:h:tf;  q=q0';q1=q0; p=p0'; p1=p0;
   [fV1 fV3]= fVm(q1);
 for i=1:N;
   p1 = p1 - bh(1)*fV1 - ch3(1)*fV3;
    for j=1:ns;
      q1 = q1 + ah(j)*fT(p1);
        [fV1 fV3]= fVm(q1);
      p1 = p1 - bh(j+1)*fV1 - ch3(j+1)*fV3;
    end
   q = [q ; q1' ];
   p = [p ; p1' ];
 end
