%             spVTVn.m
% Second order TVT-Splitting method
% fT, fV: the vectorfields
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t q p] = spVTVn(fT,fV,t0,tf,q0,p0,N)
 h = (tf-t0)/N;
  s=6;
a1=0.245298957184271;
a2=0.604872665711080;
a=[a1,a2,1/2-(a1+a2),1/2-(a1+a2),a2,a1];
b1=0.08298440641740515;
b2=0.396309801498368;
b3=-0.03905630492234859;
b=[b1,b2,b3,1-2*(b1+b2+b3),b3,b2,b1];

ah=h*a; bh=h*b;
 t=t0:h:tf;  q=q0';q1=q0; p=p0'; p1=p0;
 fV0 = fV(q1);
 for i=1:N;
   p1 = p1 - h*b(1)*fV0;
    for j=1:s;
     q1 = q1 + ah(j)*fT(p1);
     fV0 = fV(q1);
     p1 = p1 - bh(j+1)*fV0;
    end
   q = [q ; q1' ];
   p = [p ; p1' ];
 end
end
