%             spVTVnProc.m
% Second order TVT-Splitting method
% fT, fV: the vectorfields
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t q p] = spVTVnProc(fT,fV,t0,tf,q0,p0,N)
 h = (tf-t0)/N;

 s=2;
a1=-1/10;   a=[a1,1-a1];
b1=1/2-sqrt(133/132); b=[b1,1-b1];

np=3;
y1=-0.1937696215758170; y2=-0.9311511462564267; y3=0.1053624334726687;
y=[y1,y2,y3];
z1=-0.5349755290809216; z2=0.3086327690445878; z3=-0.1428375011411086;
z=[z1,z2,z3];
 
 ah=h*a; bh=h*b;  yh=h*y; zh=h*z;
 t=t0:h:tf;  q=q0';q1=q0; p=p0'; p1=p0;
    for j=1:np;
     p1 = p1 - yh(j)*fV(q1);
     q1 = q1 + zh(j)*fT(p1);
    end
 for i=1:N;
    for j=1:s;
     p1 = p1 - bh(j)*fV(q1);
     q1 = q1 + ah(j)*fT(p1);
    end
    qq1=q1;  pp1=p1;
    for j=np:-1:1;
     qq1 = qq1 - zh(j)*fT(pp1);
     pp1 = pp1 + yh(j)*fV(qq1);
    end
   q = [q ; qq1' ];
   p = [p ; pp1' ];
 end
end
